# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.form import Form
from swagger_server import util


class Workflow(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, name: str=None, forms: List[Form]=None):  # noqa: E501
        """Workflow - a model defined in Swagger

        :param id: The id of this Workflow.  # noqa: E501
        :type id: int
        :param name: The name of this Workflow.  # noqa: E501
        :type name: str
        :param forms: The forms of this Workflow.  # noqa: E501
        :type forms: List[Form]
        """
        self.swagger_types = {
            'id': int,
            'name': str,
            'forms': List[Form]
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'forms': 'forms'
        }

        self._id = id
        self._name = name
        self._forms = forms

    @classmethod
    def from_dict(cls, dikt) -> 'Workflow':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Workflow of this Workflow.  # noqa: E501
        :rtype: Workflow
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this Workflow.


        :return: The id of this Workflow.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this Workflow.


        :param id: The id of this Workflow.
        :type id: int
        """

        self._id = id

    @property
    def name(self) -> str:
        """Gets the name of this Workflow.


        :return: The name of this Workflow.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this Workflow.


        :param name: The name of this Workflow.
        :type name: str
        """

        self._name = name

    @property
    def forms(self) -> List[Form]:
        """Gets the forms of this Workflow.


        :return: The forms of this Workflow.
        :rtype: List[Form]
        """
        return self._forms

    @forms.setter
    def forms(self, forms: List[Form]):
        """Sets the forms of this Workflow.


        :param forms: The forms of this Workflow.
        :type forms: List[Form]
        """

        self._forms = forms
